# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

# Versions of Cwd < 3 mostly work so don't bother about the version
%global old_cwd %(perl -MCwd -e 'print (($Cwd::VERSION < 3) ? 1 : 0);' 2>/dev/null || echo 0)

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION < 6.30) ? 1 : 0);' 2>/dev/null || echo 0)

Name:		perl-DateTime-TimeZone
Version:	1.43
Release:	1.0.cf.%{__distinit}%{__distvers}
Summary:	Time zone object base class and factory
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/DateTime/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DR/DROLSKY/DateTime-TimeZone-%{version}.tar.gz
Patch0:		DateTime-TimeZone-1.36-old-EU::MM.patch
Patch1:		DateTime-TimeZone-1.43-old-Cwd.patch
Patch3:		DateTime-TimeZone-1.43-old-Test::More.patch
Patch4:		DateTime-TimeZone-1.35-5.8.8.patch
Patch5:		DateTime-TimeZone-1.35-spelling.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(Class::Load)
BuildRequires:	perl(Class::Singleton) >= 1.03
BuildRequires:	perl(Cwd)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Params::Validate) >= 0.72
BuildRequires:	perl(parent)
BuildRequires:	perl(Pod::Man) >= 1.14
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::More) >= 0.34
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Output)
BuildRequires:	perl(Test::Pod) >= 1.14
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Spelling), %(perl -e 'print (($] >= 5.008001) ? "aspell-en" : "aspell-en-gb")')
# DateTime used in test suite, but it wants DateTime::TimeZone for its own test suite
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(DateTime)
%endif
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Class::Singleton) >= 1.03

# Don't require Win32 modules (rpm ≥ 4.9)
%global __requires_exclude ^perl\\(Win32

%description
This class is the base class for all time zone objects. A time zone is
represented internally as a set of observances, each of which describes the
offset from GMT for a given time period.

Note that without the DateTime.pm module, this module does not do much. Its
primary interface is through a DateTime object, and most users will not need
to directly use DateTime::TimeZone methods.

%prep
%setup -q -n DateTime-TimeZone-%{version}

# Don't need ExtUtils::MakeMaker ≥ 6.30
%if %{old_eumm}
%patch0 -p1
%endif

# Can get away with Cwd < 3
%if %{old_cwd}
%patch1 -p1
%endif

# Test suite uses feature from Test::More 0.88
%if %{old_test_more}
%patch3 -p1
%endif

# DateTime::TimeZone test 04local.t tickles a Test::Builder bug in 5.8.8
%patch4 -p2

# Add extra stopwords to spellchecker test
%patch5 -p2

# Remove unwanted Win32 dependencies (rpm < 4.9)
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -v '^perl(Win32'"
%define __perl_requires %{reqfilt}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
%{_fixperms} %{buildroot}

%check
make test RELEASE_TESTING=1

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%{perl_vendorlib}/DateTime/
%{_mandir}/man3/DateTime::TimeZone.3pm*
%{_mandir}/man3/DateTime::TimeZone::Catalog.3pm*
%{_mandir}/man3/DateTime::TimeZone::Floating.3pm*
%{_mandir}/man3/DateTime::TimeZone::Local.3pm*
%{_mandir}/man3/DateTime::TimeZone::Local::Unix.3pm*
%{_mandir}/man3/DateTime::TimeZone::Local::VMS.3pm*
%{_mandir}/man3/DateTime::TimeZone::Local::Win32.3pm*
%{_mandir}/man3/DateTime::TimeZone::OffsetOnly.3pm*
%{_mandir}/man3/DateTime::TimeZone::OlsonDB.3pm*
%{_mandir}/man3/DateTime::TimeZone::UTC.3pm*

%changelog
* Thu Mar  1 2012 Paul Howarth <paul@city-fan.org> - 1.43-1.0.cf
- Update to 1.43:
  - This release is based on version 2012a of the Olson database
  - Contemporary changes for Armenia, Chile, the Falkland Islands, and Tokelau
- BR: perl(Cwd)
- BR: at least version 0.72 of perl(Params::Validate)
- Add patch to support building with Cwd < 3
- Update patch for old Test::More versions

* Mon Nov  7 2011 Paul Howarth <paul@city-fan.org> - 1.42-1.0.cf
- Update to 1.42:
  - This release is based on version 2011n of the Olson database
  - Contemporary changes for Fiji, Moldova (reversing the 2011m changes), and
    Cuba; the Moldova change removes the Europe/Tiraspol zone added in the
    previous release

* Mon Oct 24 2011 Paul Howarth <paul@city-fan.org> - 1.41-1.0.cf
- Update to 1.41:
  - This release is based on version 2011m of the Olson database
  - Contemporary changes for Brazil, Moldova, and Ukraine

* Mon Oct 10 2011 Paul Howarth <paul@city-fan.org> - 1.40-1.0.cf
- Update to 1.40:
  - This release is based on version 2011l of the Olson database
  - Contemporary changes for Palestine, Fiji, Russia, Belarus, Ukraine, and
    several other post-Soviet states

* Mon Sep 26 2011 Paul Howarth <paul@city-fan.org> - 1.39-1.0.cf
- Update to 1.39:
  - This release is based on version 2011k of the Olson database
  - Contemporary changes for Palestine, Belarus and Ukraine

* Tue Sep 20 2011 Paul Howarth <paul@city-fan.org> - 1.38-1.0.cf
- Update to 1.38:
  - Removed code matching /^package/ in tools/parse_olson, which was confusing
    the metacpan indexer

* Tue Sep 13 2011 Paul Howarth <paul@city-fan.org> - 1.37-1.0.cf
- Update to 1.37:
  - This release is based on version 2011j of the Olson database
  - Contemporary changes for Samoa and historical changes for Kenya, Uganda
    and Tanzania

* Tue Sep  6 2011 Paul Howarth <paul@city-fan.org> - 1.36-1.0.cf
- Update to 1.36:
  - This release is based on version 2011i of the Olson database
  - New zone for South Sudan (Africa/Juba)
  - Changes for Samoa, Kaliningrad (Russia), Alaska, Hawaii,
    Newfoundland/Labrador (Canada) and Resolute Bay
- Update patch for building with old ExtUtils::MakeMaker versions

* Fri Aug 19 2011 Paul Howarth <paul@city-fan.org> - 1.35-3.1.cf
- Can now do a non-bootstrap build

* Fri Aug 19 2011 Paul Howarth <paul@city-fan.org> - 1.35-3.0.cf
- Unbundle from perl-DateTime
- First build is a bootstrap build without perl(DateTime) for testing
